VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmTest 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "DC-DSP Filter Test"
   ClientHeight    =   1575
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   1575
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrPosition 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   2280
      Top             =   1080
   End
   Begin ComctlLib.Slider sldPosition 
      Height          =   480
      Left            =   120
      TabIndex        =   5
      Top             =   600
      Width           =   3855
      _ExtentX        =   6800
      _ExtentY        =   847
      _Version        =   327682
      Max             =   100000
      TickFrequency   =   5000
   End
   Begin VB.CommandButton cmdResetPitch 
      Caption         =   "Reset  Pitch"
      Height          =   375
      Left            =   2760
      TabIndex        =   8
      Top             =   1080
      Width           =   1215
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   4
      Top             =   120
      Width           =   615
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "Open"
      Height          =   375
      Left            =   2640
      TabIndex        =   3
      Top             =   120
      Width           =   615
   End
   Begin MSComDlg.CommonDialog dlgFileOpen 
      Left            =   4080
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin ComctlLib.Slider sldPitch 
      Height          =   855
      Left            =   4080
      TabIndex        =   6
      Top             =   600
      Width           =   480
      _ExtentX        =   847
      _ExtentY        =   1508
      _Version        =   327682
      Orientation     =   1
      Max             =   1999
      SelStart        =   1000
      TickFrequency   =   500
      Value           =   1000
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop"
      Enabled         =   0   'False
      Height          =   375
      Left            =   1560
      TabIndex        =   2
      Top             =   120
      Width           =   615
   End
   Begin VB.CommandButton cmdPause 
      Caption         =   "Pause"
      Enabled         =   0   'False
      Height          =   375
      Left            =   840
      TabIndex        =   1
      Top             =   120
      Width           =   615
   End
   Begin VB.CommandButton cmdPlay 
      Caption         =   "Play"
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   615
   End
   Begin VB.Label lblPitch 
      BackStyle       =   0  'Transparent
      Caption         =   "Pitch: 1000"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   1200
      Width           =   3135
   End
End
Attribute VB_Name = "frmTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private m_objFilterGraph As IAMFilterGraph
Private m_objMediaControl As IAMMediaControl
Private m_objMediaPosition As IAMMediaPosition
Private m_clsDCDSPFilterControl As New clsIDCDSPFilterInterface
Private m_clsDCDSPFilterVisual As New clsIDCDSPFilterVisualInterface
Private m_clsDCPitchScale As New clsIDCPitchScale
Private Const CLSID_DCDSPFilter = "{B38C58A0-1809-11D6-A458-EDAE78F1DF12}"
Implements IDCDSPFilterPCMCallBack
#Const DEBUG_VU = False

Private Sub cmdClose_Click()
    Call CloseFile
End Sub

Private Sub cmdOpen_Click()
    On Local Error GoTo ErrHandler
    
    dlgFileOpen.CancelError = True
    dlgFileOpen.Filter = "All Files (*.*)|*.*"
    dlgFileOpen.ShowOpen
    
    If dlgFileOpen.FileName = "" Then Exit Sub
    Call OpenFile(dlgFileOpen.FileName)
    
    If Err.Number <> CLng(0) Then Err.Clear
    On Local Error GoTo 0
    Exit Sub
    
ErrHandler:
    Err.Clear
    On Local Error GoTo 0
End Sub

Private Sub cmdResetPitch_Click()
    sldPitch.Value = CLng(1000)
End Sub

Private Sub cmdStop_Click()
    If m_objMediaControl Is Nothing Then Exit Sub
    m_objMediaControl.Stop
    m_objMediaPosition.CurrentPosition = CDbl(0)
    cmdPlay.Enabled = True
    cmdPause.Enabled = False
    cmdStop.Enabled = False
End Sub

Private Sub Form_Load()
    If Not DCDSPFilterInstalled() Then
        MsgBox "DC-DSP Filter not installed!", vbCritical + vbOKOnly, "Error"
        End
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Call CloseFile
    End
End Sub

Private Sub IDCDSPFilterPCMCallBack_Flush()
    Debug.Print "IDCDSPFilterPCMCallBack: Flush"
End Sub

Private Sub IDCDSPFilterPCMCallBack_MediaTypeChanged(Stream As DCDSPFilter.DSStream)
    Debug.Print "IDCDSPFilterPCMCallBack: Media Type Changed"
    
    With Stream
        Debug.Print "IDCDSPFilterPCMCallBack: " & "Channels - " & CStr(.Channels)
        Debug.Print "IDCDSPFilterPCMCallBack: " & "DTS - " & CStr(.DTS)
        Debug.Print "IDCDSPFilterPCMCallBack: " & "Frequency - " & CStr(.Frequency)
        Debug.Print "IDCDSPFilterPCMCallBack: " & "Size - " & CStr(.Size)
        Debug.Print "IDCDSPFilterPCMCallBack: " & "SPDIF - " & CStr(.SPDIF)
    End With
End Sub

Private Sub cmdPause_Click()
    If m_objMediaControl Is Nothing Then Exit Sub
    m_objMediaControl.Pause
    cmdPlay.Enabled = True
    cmdPause.Enabled = False
    cmdStop.Enabled = True
End Sub

Private Sub cmdPlay_Click()
    If m_objMediaControl Is Nothing Then Exit Sub
    m_objMediaControl.Run
    cmdPlay.Enabled = False
    cmdPause.Enabled = True
    cmdStop.Enabled = True
End Sub

Private Sub IDCDSPFilterPCMCallBack_PCMDataCB(Buffer As Long, ByVal Length As Long, NewSize As Long, Stream As DCDSPFilter.DSStream)
    Dim bytPCMData() As Byte
    Dim lngIndex As Long
    
    If Length > CLng(0) Then
        Call GetPCMData(Buffer, Length, bytPCMData())
        
        For lngIndex = LBound(bytPCMData) To UBound(bytPCMData)
            bytPCMData(lngIndex) = bytPCMData(lngIndex)
        Next lngIndex
        
        Call SetPCMData(Buffer, bytPCMData())
    End If
    
    NewSize = Length
End Sub

Private Sub sldPitch_Change()
    Dim lngPitch As Long
    
    lngPitch = CLng(2000) - sldPitch.Value
    
    If Not (m_clsDCPitchScale.Object Is Nothing) Then
        m_clsDCPitchScale.Pitch(0) = lngPitch
        m_clsDCPitchScale.Pitch(1) = lngPitch
        m_clsDCPitchScale.Enabled = (lngPitch <> CLng(1000))
    End If
    
    lblPitch.Caption = "Pitch: " & CStr(lngPitch)
End Sub

Private Sub OpenFile(ByVal strFileName As String)
    On Local Error GoTo ErrHandler
    Dim udtEnumFilters As IAMEnumFilters
    Dim objBaseFilter As IAMBaseFilter
    Dim lngReturn As Long
    Dim strReturn As String
    Dim lngIndex As Long
    
    Call CloseFile
    Set m_objFilterGraph = New AMFiltergraphManager
    Set m_objMediaControl = m_objFilterGraph
    Set m_objMediaPosition = m_objFilterGraph
    m_objMediaControl.RenderFile strFileName
    
    Set udtEnumFilters = m_objFilterGraph.EnumFilters()
    
    If Not (udtEnumFilters Is Nothing) Then
        Do While udtEnumFilters.Next(1, objBaseFilter) = CLng(1)
            If IsEqualGUID(objBaseFilter.ClassID, UUIDFromString(CLSID_DCDSPFilter)) Then
                Set m_clsDCDSPFilterControl.Object = objBaseFilter
                Set m_clsDCDSPFilterVisual.Object = m_clsDCDSPFilterControl.Object
                m_clsDCDSPFilterControl.DisableSaving = True
                m_clsDCDSPFilterControl.RemoveAllFilters
                Call m_clsDCDSPFilterControl.AddFilter(CLng(-1), ftPitchScale)
                Set m_clsDCPitchScale.Object = m_clsDCDSPFilterControl.FilterInterface(0)
                Call sldPitch_Change
                'Set m_clsDCDSPFilterControl.CallBackPCM = Me
                'Disabled: VB6 has problems with reading/writing the PCM data in realtime
                Exit Do
            End If
        Loop
    End If
    
    sldPosition.Enabled = True
    cmdPlay.Enabled = True
    cmdPause.Enabled = False
    cmdStop.Enabled = False
    cmdOpen.Enabled = False
    cmdClose.Enabled = True
    tmrPosition.Enabled = True
    Me.Caption = GetFileName(strFileName)
    
    On Local Error GoTo 0
    Exit Sub
    
ErrHandler:
    MsgBox "Unable to open " & strFileName & ".", vbExclamation + vbOKOnly, "Open - Error"
    Call CloseFile
End Sub

Private Sub CloseFile()
    If Not (m_objMediaControl Is Nothing) Then m_objMediaControl.Stop
    Set m_clsDCPitchScale = Nothing
    Set m_clsDCDSPFilterVisual = Nothing
    Set m_clsDCDSPFilterControl = Nothing
    Set m_objMediaPosition = Nothing
    Set m_objMediaControl = Nothing
    Set m_objFilterGraph = Nothing
    sldPosition.Value = CLng(0)
    sldPosition.Enabled = False
    cmdPlay.Enabled = False
    cmdPause.Enabled = False
    cmdStop.Enabled = False
    cmdOpen.Enabled = True
    cmdClose.Enabled = False
    tmrPosition.Enabled = False
    Me.Caption = App.Title
End Sub

Private Sub sldPosition_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    tmrPosition.Enabled = False
End Sub

Private Sub sldPosition_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If m_objMediaPosition Is Nothing Then Exit Sub
    m_objMediaPosition.CurrentPosition = (CDbl(sldPosition.Value) / CDbl(100000)) * m_objMediaPosition.Duration
    tmrPosition.Enabled = True
End Sub

Private Sub tmrPosition_Timer()
    Dim bytData() As Byte
    Dim dblAverage As Double
    Dim lngIndex As Long
    Dim lngValues As Long
    Dim udtPDSStream As DSStream
    
    If m_objMediaPosition Is Nothing Then Exit Sub
    sldPosition.Value = CLng((m_objMediaPosition.CurrentPosition / m_objMediaPosition.Duration) * CDbl(100000))
    
    #If DEBUG_VU Then
        If m_clsDCDSPFilterVisual.GetVisualData(bytData(), udtPDSStream) Then
            dblAverage = CDbl(0)
            lngValues = CLng(0)
            
            For lngIndex = CLng(0) To UBound(bytData)
                If bytData(lngIndex) <= CByte(99) Then
                    dblAverage = dblAverage + CDbl(bytData(lngIndex))
                    lngValues = lngValues + CLng(1)
                End If
            Next lngIndex
            
            If lngValues > CLng(0) Then
                dblAverage = Round(dblAverage / CDbl(lngValues), CLng(2))
                Debug.Print "VU: " & CStr(dblAverage)
            Else
                Debug.Print "VU: 0"
            End If
        Else
            Debug.Print "VU: 0"
        End If
    #End If
End Sub

Private Function GetFileName(ByVal strFileName As String) As String
    If InStrRev(strFileName, "\", CLng(-1), vbBinaryCompare) > CLng(0) Then
        GetFileName = Right$(strFileName, Len(strFileName) - InStrRev(strFileName, "\", CLng(-1), vbBinaryCompare))
    Else
        GetFileName = ""
    End If
End Function
